/*********************************************/
/* Final Project cps615                      */
/* Romberg Adaptive integration              */
/*  Name: Srinivasa Rao Chava                */
/*********************************************/

#include <mpi.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#define N 16 /* Original number of intervals*/


main(int argc, char** argv)
 {
  /* end points of intgration*/ 
  double A=0.0,local_a,local_b;
  double B=1.0,m;
  double stime,etime,dif;
  double h,k=-1; /* h is interval size*/
  double x[4],error=0.0001;
  int compute[4];
  double oldf[4],newf[4],old_sum[4], new_sum[4],total_sum[4];
  double final_sum=0.0,osum[4]; 
  int local_n, start_index,end_index,done=0;
  int my_rank,i,P,j,num,average,count,reminder;
/*Error tolerance */
  double tolerance=0.0001; 

double f(double X);

/*Let the system do what it needs to satrt up MPI */
MPI_Init(&argc,&argv);

/* get the process rank */
MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);/*

/*Find out the number of processors */
MPI_Comm_size(MPI_COMM_WORLD, &P);
stime=MPI_Wtime();
h=(B-A)/N;

/* intervals of ecach processors */
if((N%P)==0)
   {local_n=N/P;}
else
  {local_n=N/P+1;}

local_a=A+my_rank*local_n*h;
local_b=local_a+local_n*h;
start_index=my_rank*local_n;
end_index=start_index+local_n-1;
for(i=0;i<local_n;i++)
   x[i]=local_a+i*h;
   x[local_n]=local_b;
/*intializing the newf[] */ 
 for(i=0;i<N;i++)
  {compute[i]=1;
   newf[i]=0.0;}
   
   compute[local_n]=0;
   newf[local_n]=0.0;


/*Compute the end points oldf */
oldf[0]=f(x[0]);
old_sum[0]=(h/3)*oldf[0];
oldf[local_n]=f(x[local_n]);
old_sum[local_n]=(h/3)*oldf[local_n];
for(i=1;i<local_n;i++)
   {
    oldf[i]=f(x[i]);}
  

/*compute the intial value of old sum */
for(i=1;i<local_n;i++)
 {
    if((i%2)!=0)
       old_sum[i]=h/3.0 * (4*oldf[i]);
    else
       old_sum[i]=h/3.0 * (2*oldf[i]);
     
  }
while(done==0)
 {
  k++;
  h=h/2;
/*Reset the record value of array */
 for(i=0;i<local_n;i++)
     {
      oldf[i]=oldf[i]+newf[i];
      newf[i]=0;
      old_sum[i]=new_sum[i];
      new_sum[i]=0;
      }
/*Computing the new sum */
for(i=0;i<local_n;i++)
 if(compute[i]==1) 
for(j=1;j<=pow(2,k);j++)
      newf[i]=newf[i]+f(x[i]+h*(2*j-1));

 for(i=0;i<local_n;i++)
    if(compute[i]==1)
    new_sum[i]=new_sum[i]+(h/3)*2*oldf[i]+(h/3)*4*newf[i];       


MPI_Alltoall(&old_sum[0],1,MPI_DOUBLE,&osum[0],1,MPI_DOUBLE,MPI_COMM_WORLD);
MPI_Alltoall(&new_sum[0],1,MPI_DOUBLE,&total_sum[0],1,MPI_DOUBLE,MPI_COMM_WORLD);
for(i=0;i<local_n;i++)
{
 final_sum=total_sum[i]+final_sum;}
final_sum=final_sum+(2*f(x[local_n])*(h/3));
printf("final sum is: %f at rank= %d\n",final_sum, my_rank);
 
/* checking the tolerance limit */
 for(i=0;i<local_n;i++)
 { if(fabs(total_sum[i]-osum[i])<error)
      done=1;
     compute[i]=0;}
num=0;
for(i=0;i<local_n;i++)
num=num+compute[i];
if(num==0)
done=1;
 
 MPI_Barrier(MPI_COMM_WORLD);}
/*Resplitting the old intervals further */
reminder=num%P;
average=num/P;

count=0;
if(num!=0)
 {
  if(num<P)
    {
     if((N%P)==0)
         local_n=N/P;
     else
         local_n=N/P+1;
  
     start_index=local_n*my_rank;
     end_index=start_index+local_n-1;
     local_a=A+my_rank*local_n*h;
     local_b=local_a+local_n*h;     
     }
  }
etime=MPI_Wtime();
dif=etime-stime;
if (my_rank == 0)
     printf("Wall clock time is %f\n",dif);
MPI_Finalize();
}

double f(double X)
 {
   double prod;
   prod=4*(1/(1+X*X));
   return prod;}




 


    
  
